/*
  http://arduino-kid.ru
  Здесь вы всегда найдёте много нового и интересного.
*/
#include <Adafruit_Fingerprint.h>
#include <SoftwareSerial.h>

int getFingerprintIDez();

// pin #2 Зелёный провод
// pin #3 Белый провод
SoftwareSerial mySerial(2, 3);
Adafruit_Fingerprint finger = Adafruit_Fingerprint(&mySerial);

const int ELECTRICAL_LOCK = 4;      // подключаем электрозамок и красный контакт светодиода
const int LED_GREEN = 5;            // подключаем зелёный контакт светодиода
const int BUZER = 6;                // подключаем пьезоэлемент к контакту 6 ШИМ
const int BUTTON = 7;               // подключаем КНОПКУ 

void setup()  
{
  
  pinMode(ELECTRICAL_LOCK, OUTPUT);  //объявляем пин как выход.
  pinMode(LED_GREEN, OUTPUT);        //объявляем пин как выход.
  pinMode(BUTTON, INPUT_PULLUP);     // включаем внутренний pull-up резистор 
  pinMode(BUZER, OUTPUT);            //объявляем пин как выход.
  
  digitalWrite(ELECTRICAL_LOCK, LOW);//Выключаем замок
  digitalWrite(LED_GREEN, HIGH);     //Зажигаем зелёный светодиод
  digitalWrite(BUTTON, HIGH);        //Устанавливаем значение кнопки в ВЫКЛ
  
  while (!Serial);  // Если у вас Yun/Leo/Micro/Zero/...  
  Serial.begin(9600);
  finger.begin(57600); // Cкорость передачи данных для последовательного порта датчика
  
  if (finger.verifyPassword()) {
    Serial.println("Найден датчик отпечатков пальца!");
  } else {
    Serial.println("Датчик отпечатков пальца не найден");
    while (1);
  }
  Serial.println("Ожидание проверки...");
}

void loop()
{
    // Обработка нажатия кнопки
  if(digitalRead(BUTTON)==LOW)//если кнопка нажата
     {            
       digitalWrite(LED_GREEN, LOW);  
       digitalWrite(ELECTRICAL_LOCK, HIGH);
       tone(BUZER, 1000); // Включаем пищалку
       delay(50);      
     }
   else 
   {
    digitalWrite(LED_GREEN, HIGH);  
    digitalWrite(ELECTRICAL_LOCK, LOW);
   }
  noTone(BUZER); // выключаем пищалку
  getFingerprintIDez();
  delay(50);
}

uint8_t getFingerprintID() {
  uint8_t p = finger.getImage();
  switch (p) {
    case FINGERPRINT_OK:
      Serial.println("Image taken");
      break;
      return p;
  }

  p = finger.image2Tz();
  switch (p) {
    case FINGERPRINT_OK:
      Serial.println("Image converted");
      break;
      return p;
  }
  

  p = finger.fingerFastSearch();
  if (p == FINGERPRINT_OK) {
    Serial.println("Найдено совпадение отпечатков пальцев!");
  } else if (p == FINGERPRINT_PACKETRECIEVEERR) {
    Serial.println("Ошибка связи");
    return p;
  } else if (p == FINGERPRINT_NOTFOUND) {
    Serial.println("Совпадений не найдено");
    return p;
  } else {
    Serial.println("Неизвестная ошибка");
    return p;
  }  
}

// returns -1 if failed, otherwise returns ID #
int getFingerprintIDez() {
  uint8_t p = finger.getImage();
  if (p != FINGERPRINT_OK)  return -1;

  p = finger.image2Tz();
  if (p != FINGERPRINT_OK)  return -1;

  p = finger.fingerFastSearch();
  if (p != FINGERPRINT_OK)  return -1;
  
  // результат поиска!
  if(finger.fingerID){
    digitalWrite(LED_GREEN, LOW);  
    digitalWrite(ELECTRICAL_LOCK, HIGH);   
    tone(BUZER, 1000);                     // Включаем пищалку  
    Serial.println(digitalRead(ELECTRICAL_LOCK));
    Serial.print("ID № "); Serial.print(finger.fingerID); 
    Serial.print(" с точностью "); Serial.println(finger.confidence);
    delay(5000);
  }
  digitalWrite(ELECTRICAL_LOCK, LOW); 
  digitalWrite(LED_GREEN, HIGH);   
  Serial.println(digitalRead(ELECTRICAL_LOCK));
  return finger.fingerID; 
}
